<template>
  <b-loading
    :is-full-page="isFullPage"
    :active.sync="active"
    :can-cancel="canCancel"
    :class="{
      [$style.container]: !isCardContent,
      [$style['card-content']]: isCardContent,
      [$style['no-opacity']]: noOpacity
    }"
    data-cy="loader"
  >
    <img
      v-if="!customIcon"
      src="@/assets/images/logo_loading_gif.gif"
      alt="Loading..."
      :class="iconClass"
    />
    <b-icon v-else v-bind="customIcon"> </b-icon>
  </b-loading>
</template>

<script>
export default {
  name: 'CLoading',
  props: {
    isFullPage: {
      type: Boolean,
      default: false
    },
    isActive: {
      type: Boolean,
      default: true
    },
    canCancel: {
      type: Boolean,
      default: true
    },
    noOpacity: {
      type: Boolean,
      default: false
    },
    customIcon: {
      type: Object,
      default: null
    },
    size: {
      validator: function(value) {
        return ['small', 'medium', 'large', 'auto'].includes(value)
      },
      default: 'auto'
    }
  },

  computed: {
    active: {
      get: function() {
        return this.isActive
      },
      set: function(val) {
        this.$emit('update:isActive', val)
        this.$emit('active-change', val)
      }
    },
    iconClass() {
      return [
        this.$style.img,
        {
          [this.$style.small]: this.isCardContent
        }
      ]
    },
    isCardContent() {
      return this.size === 'small'
    }
  }
}
</script>

<style lang="scss" module>
@import '@/assets/styles/variables';

.no-opacity {
  :global(.loading-background) {
    background: $white !important;
  }
}
.img {
  z-index: 0;
}
.small {
  width: 36.8px;
}
.container {
  position: fixed !important;
}
.card-content {
  &:global(.loading-overlay) {
    z-index: 8 !important;
  }
}
</style>
